/*
 * GyroKit Copyright J. Fourcade
 * E-mail : autogire@volucres.fr
 * Web site : http://www.volucres.fr\
 * This software is a flight dynamics library whose purpose is to simulate
 * the behavior of rotating-wing aircrafts.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info\
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer and aerodynamic knowledge.
 * Users are therefore encouraged to load and test the software's suitability
 * as regards their requirements in conditions enabling the security of their
 * systems and/or data to be ensured and,  more generally, to use and
 * operate it in the same conditions as regards security.
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms
 */
package gui.Utils;

import java.util.Properties;
import javax.swing.JLabel;
import javax.swing.JTextField;
import main.utils.Units;
import main.utils.Units.UnitsList;

/**
 *
 * @author J. Fourcade
 */
public class EntryReal {

    /**
     *
     * @param field
     * @param format
     * @param fieldUnit
     * @param unit
     */
    public static void unitUpdate(JLabel field, String format, JLabel fieldUnit, UnitsList unit) {
        Double value = Double.parseDouble(field.getText().replace(",", "."));
        field.setText(String.format(format, Units.unitSystemConvert(value, unit)));
        fieldUnit.setText(Units.getLabel(unit));

    }

    /**
     *
     * @param field
     * @param format
     * @param fieldUnit
     * @param unit
     */
    public static void unitUpdate(JTextField field, String format, JLabel fieldUnit, UnitsList unit) {
        Double value = Double.parseDouble(field.getText().replace(",", "."));
        field.setText(String.format(format, Units.unitSystemConvert(value, unit)));
        fieldUnit.setText(Units.getLabel(unit));
    }

    /**
     *
     * @param field
     * @param value
     * @param format
     * @param unit
     */
    public static void set(JLabel field, double value, String format, UnitsList unit) {
        field.setText(String.format(format, Units.convertValueFromSI(value, unit)));
    }
    
    /**
     *
     * @param field
     * @param value
     * @param format
     * @param unit
     */
    public static void set(JTextField field, double value, String format, UnitsList unit) {
        field.setText(String.format(format, Units.convertValueFromSI(value, unit)));
    }

    /**
     *
     * @param field
     * @param value
     * @param format
     */
    public static void set(JLabel field, double value, String format) {
        field.setText(String.format(format, value));
    }
    
    /**
     *
     * @param field
     * @param value
     * @param format
     */
    public static void set(JTextField field, double value, String format) {
        field.setText(String.format(format, value));
    }
    
    /**
     *
     * @param field
     * @param value
     * @param format
     * @param numeratorUnit
     * @param denominatorUnit
     */
    public static void set(JLabel field, double value, String format, UnitsList numeratorUnit,
            UnitsList denominatorUnit) {
        field.setText(String.format(format, Units.convertDerivativeFromSI(value, 
                numeratorUnit,denominatorUnit)));
    }

    /**
     *
     * @param field
     * @return
     */
    public static double read(JTextField field) {
        return Double.parseDouble(field.getText().replace(",", "."));

    }

    /**
     *
     * @param field
     * @param unit
     * @return
     */
    public static double read(JTextField field, UnitsList unit) {
        return Units.convertValueToSI(Double.parseDouble(field.getText().replace(",", ".")),
                unit);
    }

    /**
     *
     * @param prop
     * @param field
     * @param label
     */
    public static void writeProperties(Properties prop, JTextField field, String label) {
        prop.setProperty(label, field.getText().replace(",", "."));
    }

    /**
     *
     * @param prop
     * @param field
     * @param label
     */
    public static void readProperties(Properties prop, JTextField field, String label) {
        field.setText(prop.getProperty(label));
    }
}
